<?php

use Carerix\Api\Rest\Entity\CRWorkHistory;

class Entity_Carerix_WorkExperience {

    private $postValues = array();
    private $workHistories = null;
    private static $count = 0;
    
    private $values = array(
        'employer' => '',
        'periodOf' => '',
        'periodUntil' => '',
        'functionName' => '',
        'workLocation' => '',
        'position' => '',
        'position_level_1' => '',
        'position_level_2' => '',
        'industry' => '',
        'sector' => '',
        'assignment' => '',
    );

    public function __construct($values, $employee) {
        $this->postValues = $values;
        $this->workHistories = $employee;
    }
    
    public function getData() {

        /**
         * empty data
         */
        if(count($this->postValues) <= 0 && $this->workHistories === null) {
            self::$count++;
            return $this->values;
        }
        
        /**
         * there are some post data. Post data has priority over carerix data
         */
        if(count($this->postValues) > 0) {
            
            foreach($this->values as $fieldName => &$value) {
                if(   isset($this->postValues[$fieldName])
                   && isset($this->postValues[$fieldName][self::$count])) {
                    $value = $this->postValues[$fieldName][self::$count];
                }
            }
            
            self::$count++;
            return $this->values;
        }
        
        /**
         * if it reached this point, there are no post data, carerix data has 
         * priority
         */
        if(   $this->workHistories !== null 
           && isset($this->workHistories[self::$count])) {
            
            /** @var CRWorkHistory ToDo */
            $workHistory = $this->workHistories[self::$count];
            foreach($this->values as $fieldName => &$value) {
                switch($fieldName) {
                    case 'employer':
                        $value = $workHistory->employer;
                        break;
                    case 'periodOf':
                        $value = $workHistory->getStartDate();
                        break;
                    case 'periodUntil':
                        $value = $workHistory->getEndDate();
                        break;
                    case 'functionName':
                        $value = $workHistory->getFunction();
                        break;
                    case 'workLocation':
                        $value = $workHistory->getWorkLocation();
                        break;
                    case 'position':
                        $node = $workHistory->getToProductTypeNode();
                        $value = '';
                        if($node) {
                            $value = $workHistory->getToProductTypeNode()->getId();   
                        }
                        break;
                    case 'position_level_1':
                        $node = $workHistory->getToFunctionLevel1();
                        $value = '';
                        if($node) {
                            $value = $workHistory->getToFunctionLevel1()->getId();   
                        }
                        break;
                    case 'position_level_2':
                        $node = $workHistory->getToFunctionLevel2();
                        $value = '';
                        if($node) {
                            $value = $workHistory->getToFunctionLevel2()->getId();   
                        }
                        break;
                    case 'industry':
                        $node = $workHistory->getToBrancheLevel1();
                        $value = '';
                        if($node) {
                            $value = $workHistory->getToBrancheLevel1()->getId();   
                        }
                        break;
                    case 'sector':
                        $node = $workHistory->getToBrancheLevel2();
                        $value = '';
                        if($node) {
                            $value = $workHistory->getToBrancheLevel2()->getId();   
                        }
                        break;
                    case 'assignment':
                        $value = $workHistory->getInfo();
                        break;
                    default:
                        $methodName = 'get'.ucfirst($fieldName);
                        $value = $workHistory->$methodName();
                        break;
                }
            }
            
            self::$count++;
            return $this->values;
        }
    }
}