<?php
$ajax_nonce_synchronize_single_source  = wp_create_nonce( "synchronize_single_source" );
$ajax_nonce_save_source  = wp_create_nonce( "save_source" );

function my_format_TinyMCE( $in ) {
	$in["forced_root_block"] = false;
	$in["force_br_newlines"] = true;
	$in["force_p_newlines"] = false;
	$in["convert_newlines_to_brs"] = true;
	$in['remove_linebreaks'] = false;
	$in['wpautop'] = false;
	$in['apply_source_formatting'] = false;
	return $in;
}
add_filter( 'tiny_mce_before_init', 'my_format_TinyMCE' );

function my_wp_editor( $content, $editor_id ): void {
	$settings = array(
		'wpautop' => false,
		'textarea_name' => $editor_id,
		/*'textarea_rows' => 20,*/
		/*'media_buttons' => false,*/
		'teeny' => false,
		'tinymce' => false,
	);
	wp_editor( $content, $editor_id, $settings );
}

?>
<form method="post" class="undoable">
<?php wp_nonce_field('source_edit', '_carerix_nonce_field'); ?>
<?php $action = isset($edit_data['id']) ? "edit" : "new"; ?>
<input type="hidden" value="<?php echo @$edit_data['id']; ?>" name="id" id="source_id">
	
<div class="wrap">
	<div id="icon-edit-pages" class="icon32 icon32-posts-page"><br></div>

	<h2><?php echo $action=="new" ? "Add New" : "Edit"; ?> Jobs Source</h2>
	
    <div class="carerix_msgBox carerix_error" id="sync_error_message" style="display: none;" >
        The Jobs feed can not be reached on <?php echo Environment_Installation::getAppName(); ?>.carerix.com/cxtools . Check that the application name was correctly set. If the problem persists please inform your Carerix Administrator 
    </div>

    <div class="carerix_msgBox carerix_ok" id="half_success_message" style="display: none;">
        The Jobs source was successfully saved<?php /*, but there were no publications available for this source */?>.
    </div>
	
    <div class="carerix_msgBox carerix_ok" id="success_message" style="display: none;">
        The Jobs source was successfully saved. 
        <?php
/*            if (@$edit_data['id']) {
                $url_to_sources = get_admin_url() . "admin.php?page=carerix_general_page&tab=carerix_settings_page#section_sync";
                echo sprintf('Please do an "enforce full sync" (see <a href="%s">Carerix->Settings</a>) to update the vacancies.', $url_to_sources);
            } */
        ?>
    </div>
	
	
	<div class="carerix_msgBox carerix_note">
        Enter the name of the source and click Save. Optionally you can add more parameters to the feed source.
    </div>


	<div id="poststuff">

		<div id="post-body" class="metabox-holder columns-2">

			<div id="post-body-content">
				<div id="titlediv">
					<div id="titlewrap">
						<h2>Source Name</h2>
						<input type="text" name="name" value="<?php echo $edit_data['name'] ?? ""; ?>" size="30" id="title" autocomplete="off" class="<?php if( isset($title_error) && strlen($title_error) ) echo "carerix_field_error"; ?>">
                        <p class="carerix_field_error" style="display: none;" id="title_error_message">The page name is mandatory</p>
					</div>
				</div>
			</div>

            <div class="postbox-container">
                <div class="postbox">
                    <h2>Publication Details Options</h2>
                    <div class="inside">
                        <table id="newmeta">
                            <tbody>
                            <tr>
                                <td style="vertical-align: middle; padding-right: 16px;">
                                    Apply form to use
                                </td>
                                <td>
                                    <select name="apply_form">
						                <?php foreach ($apply_forms as $apply_form): ?>
							                <?php $selected = ($apply_form['id'] == @$edit_data['settings']['apply_form']) ? "selected" : ""; ?>
							                <?php echo "<option $selected value='{$apply_form['id']}' >{$apply_form['name']}</option>"; ?>
						                <?php endforeach; ?>
                                    </select>
                                </td>
                            </tr>
                            <tr>
                                <td style="vertical-align: middle; padding-right: 16px;">
                                    Create Post Title as
                                </td>
                                <td>
                                    <fieldset>
						                <?php
						                $selected_title_location = '';
						                $selected_title_title    = '';

						                if (!isset($edit_data['settings']['title_compose'])
							                || $edit_data['settings']['title_compose'] == 'location')
						                {
							                $selected_title_location = 'checked';
						                }
						                else
						                {
							                $selected_title_title = 'checked';
						                }
						                ?>
                                        <label for='just_title'><input id='just_title' type='radio'
                                                                       name='title_compose' <?php echo $selected_title_title; ?>
                                                                       value='title'/> Title</label>
                                        &nbsp;&nbsp;
                                        <label for='and_location'><input id='and_location' type='radio'
                                                                         name='title_compose' <?php echo $selected_title_location; ?>
                                                                         value='location'/> Title - Location</label>
                                    </fieldset>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                    </div>

                    <br style="clear: both;">

                    <h2>Set Alternative Feed Source Parameters</h2>
                    <div class="inside">
                        <div>
                            By default the medium-code `web` (own website) is used. So, all vacancies published to medium-code `web` are retrieved.<br>
                            If you publish vacancies to a different medium-code in your Carerix system, you can configure it here.<br>
                            Suppose you've setup the medium-code `mysecondbrand` with some publications running on it, you need to fill in: <code>medium=mysecondbrand</code>
                        </div>
                        <br style="clear: both;">
                        <code style="display: inline-block;"><?php echo Environment_Installation::get_publications_feed(); ?>?</code><input type="text" name="feed" size="30" autocomplete="off" placeholder="e.g: medium=mysecondbrand" style="padding: 3px 8px; font-size: 1em; display: inline-block; line-height: 100%; outline: none;" value="<?php echo @$edit_data['settings']['feed'] ; ?>">
                    </div>
                </div>
            </div>

<?php
/** @deprecated page introtext isn't used for vacancy posts rendering. It is used for rendering a "page-type post" which isn't used anymore
 *
 *
            <br style="clear: both;">
            <br style="clear: both;">

            <div class="postbox-container">
                <div class="postbox">
                    <h2>Page intro text</h2>
                    <div class="inside" >
                        <?php wp_editor( @$edit_data['settings']['introtext'], "introtext" ); ?>
                    </div>
                </div>
            </div>
*/
?>

            <br style="clear: both;">
            <br style="clear: both;">

            <div class="postbox-container">
                <div class="postbox">
                    <h2>Publication Excerpt</h2>
                    <div class="inside">
                        <div>
                            Excerpts (teasers) are useful for pages where you want to display an overview/listing of the vacancies. Most of the time you want to
                            show a short teaser-text with a "read more" button which links to the full vacancy page.<br>
                            <br>
                            Note! Make sure your theme supports the <a href="https://developer.wordpress.org/reference/functions/the_excerpt/" target="_blank">`the_excerpt()`</a> functionality, else
                            the traditional read-more (&lt;!--more--&gt;) method will be used to split the vacancy text in an excerpt-text and a main-text. If you use the "default template", you can see
                            the <b>dashed line</b> in the editor of the "Publication Details Body" section (scroll down) is used for splitting.<br>
                            <br>
                            Useful shortcode:<br>
                            <ul>
                                <li>
                                    <input type="text" onfocus="this.select();" readonly="readonly" value='[cx_intro_information heading="no"]' style="width: 240px; text-align: center; border: none;"> to display the vacancy introduction text <b>without</b> the leading &lt;h4&gt;-heading
                                </li>
                            </ul>
                        </div>
						<?php
                            if ( strlen(trim($edit_data['settings']['excerpt'] ?? "") ) == 0 ) {
                                $edit_data['settings']['excerpt'] = Entity_Source_Job::EXCERPT_TEMPLATE;
                            }
						    my_wp_editor( $edit_data['settings']['excerpt'] ?? "", "excerpt");
                        ?>
                    </div>
                </div>
            </div>


            <br style="clear: both;">
			<br style="clear: both;">
            
            <div class="postbox-container">
                <div class="postbox">
                    <h2>Publication Details Header</h2>
                    <div class="inside">
                        <div>
                            <p>
                            This text will be prepended to the body text.
                            </p>
                        </div>
                        <?php
                           my_wp_editor( $edit_data['settings']['header'] ?? "", "header");
                        ?>
                    </div>
                </div>
            </div>


            <br style="clear: both;">
            <br style="clear: both;">



			<?php
//                $job = new Entity_Writer_Job( null );
//                $dflt_tpl = $job->getDefaultTemplate();
                // $edit_data['settings']['bodytext'] = print_r($sections, true);
			?>
            <div class="postbox-container">
                <div class="postbox">
                    <h2>Publication Details Body</h2>
                    <div class="inside" >
                        <div>
                            <p>
                                This is the main vacancy template. You can use shortcodes to format the text. If you empty the editor, the default template will be restored after saving.
                            </p>

                            <p>
                                Useful shortcodes to construct the vacancy text:
                            </p>

                            <ul>
                                <li>
                                    <input type="text" onfocus="this.select();" readonly="readonly" value='[cx_intro_information]' style="width: 250px; text-align: center; border: none;">
                                </li>
                                <li>
                                    <input type="text" onfocus="this.select();" readonly="readonly" value='[cx_company_information]' style="width: 250px; text-align: center; border: none;">
                                </li>
                                <li>
                                    <input type="text" onfocus="this.select();" readonly="readonly" value='[cx_vacancy_information]' style="width: 250px; text-align: center; border: none;">
                                </li>
                                <li>
                                    <input type="text" onfocus="this.select();" readonly="readonly" value='[cx_requirements_information]' style="width: 250px; text-align: center; border: none;">
                                </li>
                                <li>
                                    <input type="text" onfocus="this.select();" readonly="readonly" value='[cx_offer_information]' style="width: 250px; text-align: center; border: none;">
                                </li>
                                <li>
                                    <input type="text" onfocus="this.select();" readonly="readonly" value='[cx_function_contact_information]' style="width: 250px; text-align: center; border: none;">
                                </li>
                                <li>
                                    <input type="text" onfocus="this.select();" readonly="readonly" value='[cx_application_contact_information]' style="width: 250px; text-align: center; border: none;">
                                </li>
                            </ul>

                            <p>
                                You can use the following shortcode attributes:
                            </p>

                            <ul style="list-style: inherit; padding-left: 16px; margin-top:0;">
                                <li><b>heading="no"</b> to hide the leading heading, or <b>heading="h1..h4"</b> to use a specific one. E.g. <b>[cx_offer_information heading="h3"]</b></li>
                                <li><b>content="no"</b> to hide the paragraph text. Useful if you only want to render the heading. E.g. <b>[cx_offer_information content="no"]</b></li>
                                <li><b>class="yourCustomClassHere"</b> to prepend a custom css class into the heading tag. E.g. <b>[cx_offer_information class="myHead"]</b></li>
                                <li><b>quotes="single"</b> to render the heading tag with single quoted attributes. Only useful for specific compatibilty reasons. E.g. <b>[cx_offer_information quotes="single"]</b></li>
                                <li><b>raw="yes"</b> to remove extra HTML (container divs) from the paragraph text. Normally not used. E.g. <b>[cx_offer_information raw="yes"]</b></li>
                            </ul>
                        </div>
						<?php
                            if ( strlen(trim($edit_data['settings']['bodytext'] ?? "") ) == 0 ) {
                                $edit_data['settings']['bodytext'] = Entity_Source_Job::BODYTEXT_TEMPLATE;
                            }
						    my_wp_editor( $edit_data['settings']['bodytext'] ?? "", "bodytext");
                        ?>
                    </div>
                </div>
            </div>


            <div class="postbox-container">
                <div class="postbox">
                    <h2>Publication Details Footer</h2>
                    <div class="inside">
                        <div>
                            Useful shortcodes:
                            <ul>
                                <li>
                                    <input type="text" onfocus="this.select();" readonly="readonly" value="[cx_apply_button]" style="width: 130px; text-align: center; border: none;"> to generate an apply-button linking to the apply form
                                </li>
                                <li>
                                    <input type="text" onfocus="this.select();" readonly="readonly" value="[cx_apply_form]" style="width: 130px; text-align: center; border: none;"> to generate an inline apply form. Use this shortcode if you want to display the application form below the vacancy text
                                </li>
                            </ul>
                        </div>
			            <?php
                            /**
                             * [cx_apply_button] shortcode is not mandatory anymore in Sources->Source edit->Publication Details Footer
                             *
                             * @since 2.20.1
                             */

                            if ( strlen(trim($edit_data['settings']['footer'] ?? "") ) == 0 ) {
	                            if ($action == "new") {
                                    $edit_data['settings']['footer'] = Entity_Source_Job::FOOTERTEXT_TEMPLATE;
	                            }
                            }

//    			            if(!isset($edit_data['settings']['footer']) || strlen(trim($edit_data['settings']['footer'])) <=0 )  :
//                                if ($action == "new") {
//                                    $edit_data['settings']['footer'] = Entity_Source_Job::FOOTERTEXT_TEMPLATE;
//                                } else {
//                                    $edit_data['settings']['footer'] = '';
//                                }
//                            endif;
			            ?>

			            <?php
			                my_wp_editor( $edit_data['settings']['footer'] ?? "", "footer");
                        ?>
                    </div>
                </div>
            </div>

            <div>
                <div class="carerix_msgBox carerix_note">
                    The synchronization with Carerix process will start after clicking Save. This might take a few seconds. Do not close this page until the confirmation message is displayed.
                </div>
                <div id="sync_error" class="carerix_msgBox carerix_error" style="display: none;">
                    Error: the synchronization process for this Jobs source failed. Please try again. If the problem persists please contact your Carerix administrator.
                </div>
                <button name="save" id="save" class="button button-primary button-large"><i class="fa fa-refresh fa-spin wait" style="display: none;"></i> Save</button>
                <a href="<?php echo $cancel_link; ?>" class="button button-large right">Cancel</a>
            </div>

		</div>
		
	</div>
	
</div>
	
</form>

<script type="text/javascript">
    jQuery(document).ready(function(e){
        $ = jQuery;
        
        $('#brief_section').click(function(e){

            var checked = $('#brief_section').is(':checked');
            if(checked) {
                $('.brief_controlled').fadeIn();
            } else {
                $('.brief_controlled').fadeOut();
            }
        });
        
        $("#save").click(function(e){
           e.preventDefault();
           $("#sync_error").hide();
           $("#success_message").hide();
           $("#sync_error_message").hide();
           $("#title_error_message").hide();
           $('#title').removeClass('carerix_field_error');
           var self = this;
           
           var richEditors = ['excerpt', 'header', 'bodytext', 'footer'];

           var selector = '';
           var selectorValue = '';
           var tiny;
           for(var i = 0; i < richEditors.length; i++) {
               selector = richEditors[i];
                if( typeof tinyMCE != "undefined" && tinyMCE.editors[i] !== undefined && tinyMCE.editors[i].isHidden() === false ) {
                    tiny = true;
                    selectorValue = tinyMCE.editors[i].getContent();
                } else {
                    tiny = false;
                    selectorValue = $('#'+selector).val();
                }

                if (selector === "bodytext" && selectorValue === "") { // Set default template
                    selectorValue = `<?php echo Entity_Source_Job::BODYTEXT_TEMPLATE; ?>`;
                    if ( tiny ) tinyMCE.editors[i].setContent(selectorValue);
                }

                $("#"+selector).val(selectorValue);
           }

           var $data = $("form.undoable").serialize();
           var url = ajaxurl + '?' +$data;
           
           var spinner = $(self).find('.wait').show();
           $(self).attr('disabled', 'disabled');
           
           var data = {
               action: 'save_source',
               security: '<?php echo $ajax_nonce_save_source; ?>',
               type: 'job'
           };
           
           var stepErrors = {};
           var setStepError = function(step) {
               if(stepErrors[step]) {
                   stepErrors[step] = stepErrors[step] + 1;
               } else {
                   stepErrors[step] = 1;
               }
           };
           
           var maximumReached = function(step) {
               var max = 3;
               if(stepErrors && stepErrors[step] >= max) {
                   return true;
               }
               return false;
           };

           var cron = function(type, source_id, page) {
               if(maximumReached(page)) {
                   $("#sync_error").fadeIn();
                   spinner.hide();
                   $(self).removeAttr('disabled');
                   return;
               }
               
               var data = {
                 action: 'synchronize_single_source',
                 security: '<?php echo $ajax_nonce_synchronize_single_source; ?>',
                 type: type,
                 id: source_id,
                 page: page
               };
               
               $.post(ajaxurl, data, function(response, status, jqXHR) {
                   if(response && response.ok) {
                       if(response.hasMore) {
                           cron(type, source_id, page+1);
                       } else {
                           spinner.hide();
                           $(self).removeAttr('disabled');
                           // success message
                            
                            var link = response.post;
                            if(link === false) {
                                var half_success = $('#half_success_message');
                                half_success.fadeIn();
                                var offset = half_success.offset();
                                offset.left -= 40;
                                offset.top -= 40;

                            } else {
                                var success = $("#success_message");
                                success.fadeIn();
                                var offset = success.offset();
                                offset.left -= 40;
                                offset.top -= 40;
                                var title = $("#title").val();
                            
                                $("#page_link").attr('href', link);
                                $("#page_title").text(title);
                            }
                            $('html, body').animate({
                                scrollTop: offset.top,
                                scrollLeft: offset.left
                            });
                            
                            $("form.undoable").data("changed", false);
                       }
                   } else {
                       cron(type, source_id, page);
                       setStepError(page);
                   }
               }, 'json').fail(function(){
                   cron(type, source_id, page);
                   setStepError(page);
               });
           };
           
           $.post(url, data, function(response, status, jqXHR){
               //spinner.hide();
               //$(self).removeAttr('disabled');
               if(response['success']) {
                   $("#source_id").val(response["id"]);

                  cron('job', response["id"], 0);
               }

               if(response['title_error']) {
                   var title_error = $("#title_error_message");
                   title_error.fadeIn();
                   $('#title').addClass('carerix_field_error');
                   var offset = $('#title').offset();
                   offset.left -= 100;
                   offset.top -= 100;
                   
                   $('html, body').animate({
                       scrollTop: offset.top,
                       scrollLeft: offset.left
                   });
                   spinner.hide();
                   $(self).removeAttr('disabled');
               }
               
           }, 'json');
           return false;
        });
    });
</script>