<?php /** @noinspection PhpUndefinedVariableInspection */
use Gregwar\Captcha\CaptchaBuilder;

$interfacer = WP_Interfacer::getInstance();
$labels = Utils_Labels::get($interfacer->get_default_site_language());

$email = '';
if (isset($_POST['email'])) {
    $email = sanitize_email($_POST['email']);
}

$firstname = '';
if (isset($_POST['firstname'])) {
    $firstname = sanitize_text_field($_POST['firstname']);
}

$lastname = '';
if (isset($_POST['lastname'])) {
    $lastname = sanitize_text_field($_POST['lastname']);
}

$lastNamePrefix = '';
if (isset($_POST['lastNamePrefix'])) {
    $lastNamePrefix = sanitize_text_field($_POST['lastNamePrefix']);
}

$gender = '';
if (isset($_POST['gender'])) {
    $gender = sanitize_text_field($_POST['gender']);
}

$functionLevel1 = '';
if (isset($_POST['functionLevel1'])) {
	$functionLevel1 = sanitize_text_field($_POST['functionLevel1']);
}

$functionLevel1_2 = '';
if (isset($_POST['functionLevel1_2'])) {
	$functionLevel1_2 = sanitize_text_field($_POST['functionLevel1_2']);
}




?>


<?php if(@$succesful): ?>
	<div id="subscribe_success">
        <?php
            if (strlen($confirmation_url)) :
	            echo "<script type=\"text/javascript\">window.location = \"{$confirmation_url}\";</script>";
            else :
        ?>
            <h3 class="cx_h3"><?php echo $labels['general.button.subscribe']; ?></h3>
            <br>
            <p class="success cx_msgBox_success cx_default_style_success">
                <?php echo strlen($confirmation_message) ? $confirmation_message : $labels['CxWpPlugin.message.jobalertsuccess']; ?>
            </p>
            <br>
        <?php endif; ?>
	</div>
<?php else: ?>
    <div id="subscribe_form">
	    <form method="post">
            <?php wp_nonce_field('subscribe', '_carerix_nonce_field'); ?>
            <div id="email_container">
                <label for="email"><?php echo $labels['general.header.email']; ?></label>
                <div>
                    <input type="email" class="carerix_input cx2_input carerix_required cx2_required" name="email" id="email" value="<?php echo $email; ?>">
                </div>
                <?php if (@$errors['email']): ?>
                    <span class="error">
                        <?php echo $errors['email']; ?>
                    </span>
                <?php endif; ?>
            </div>
	
            <div id="firstname_container">
                <label for="firstname"><?php echo $labels['general.message.field.firstName']; ?></label>
                <div>
                    <input type="text" name="firstname" id="firstname" value="<?php echo $firstname; ?>">
                </div>
                <?php if (@$errors['firstname']): ?>
                    <span class="error">
                        <?php echo $errors['firstname']; ?>
                    </span>
                <?php endif; ?>
            </div>

            <div id="lastnameprefix_container">
		        <label for="lastNamePrefix"><?php echo $labels['CxPortal.message.field.middleName']; ?></label>
		        <div>
		            <input type="text" name="lastNamePrefix" id="lastNamePrefix" value="<?php echo $lastNamePrefix; ?>">
		        </div>
	        </div>
            
	        <div id="lastname_container">
		        <label for="lastname"><?php echo $labels['general.message.field.lastName']; ?></label>
		        <div>
		            <input class="carerix_required" type="text" name="lastname" id="lastname" value="<?php echo $lastname; ?>">
		        </div>
                <?php if (@$errors['lastname']): ?>
                    <span class="error">
                        <?php echo $errors['lastname']; ?>
                    </span>
                <?php endif; ?>
            </div>
	
            <div id="gender_container">
                <label for="gender"><?php echo $labels['general.message.field.gender']; ?></label>
                <div>
                    <select class="<?php if (Environment_Settings::getFormGenderUnknown() !== 'on'): ?>carerix_required<?php endif; ?>" name="gender" id="gender">
                        <?php foreach($genders as $genderOption): ?>
                            <?php $selected = ($genderOption['id'] == $gender) ? "selected " : ""; ?>
                            <option <?php echo $selected; ?>value="<?php echo $genderOption['id']; ?>"><?php echo $genderOption['value'];?></option>
                        <?php endforeach; ?>
                    </select>
                </div>

                <?php if (@$errors['gender']): ?>
                    <span class="error">
                        <?php echo $errors['gender']; ?>
                    </span>
                <?php endif; ?>
            </div>

            <div id="countryregions_container">
                <label for="prefCountry1Node"><span id="prefRegionLabel"><?php // echo $labels['general.message.field.country'] . " / "; ?><?php echo $labels['general.message.field.regions']; ?></span></label>
                <div>
                    <?php if (count($countryRegions) == 1) : ?>
                        <?php $initialRegionsDisplayStyle = ""; ?>
                        <input type="hidden" name="prefCountry1Node" id="prefCountry1Node" value="<?php echo $countryRegions[0]['id']; ?>" data-related="prefRegion1Node" data-related2="prefRegion2Node" data-related3="prefRegion3Node" data-related4="prefRegion4Node" data-type="countries">
                    <?php else: ?>
                        <select name="prefCountry1Node" id="prefCountry1Node" data-related="prefRegion1Node" data-related2="prefRegion2Node" data-related3="prefRegion3Node" data-related4="prefRegion4Node" data-type="countries">
                            <option value=""></option>
		                    <?php foreach($countryRegions as $countryRegion) : ?>
                                <option value="<?php echo $countryRegion['id']; ?>"><?php echo $countryRegion['value'];?></option>
		                    <?php endforeach; ?>
                        </select>
	                    <?php $initialRegionsDisplayStyle = "display: none;"; ?>
                    <?php endif; ?>
                </div>
                <div id="prefRegion1Node_container" style="<?php echo $initialRegionsDisplayStyle; ?>">
                    <select name="prefRegion1Node" id="prefRegion1Node"></select>
                </div>
                <?php if (@$errors['prefCountry1Node']): ?>
                    <span class="error">
                        <?php echo $errors['prefCountry1Node']; ?>
                    </span>
                <?php endif; ?>
                <div id="prefRegion2Node_container" style="<?php echo $initialRegionsDisplayStyle; ?>">
                    <select name="prefRegion2Node" id="prefRegion2Node"></select>
                </div>
                <?php if (@$errors['prefCountry2Node']): ?>
                    <span class="error">
                        <?php echo $errors['prefCountry2Node']; ?>
                    </span>
                <?php endif; ?>
                <div id="prefRegion3Node_container" style="<?php echo $initialRegionsDisplayStyle; ?>">
                    <select name="prefRegion3Node" id="prefRegion3Node"></select>
                </div>
                <?php if (@$errors['prefCountry3Node']): ?>
                    <span class="error">
                        <?php echo $errors['prefCountry3Node']; ?>
                    </span>
                <?php endif; ?>
            </div>

            <div id="functions_container">
                <label for="functionLevel0"><?php echo $labels['CxPortal.header.businessLines']; /*$labels['general.message.field.functionLevel']*/ ?></label>
                <div>
	                <?php if (count($functionLevels) == 1) : ?>
		                <?php $initialBusinesslineDisplayStyle = ""; ?>
                        <input type="hidden" name="functionLevel0" id="functionLevel0" value="<?php echo $functionLevels[0]['id']; ?>" data-related="functionLevel1" data-type="functions">
	                <?php else: ?>
                        <select class="carerix_required" name="functionLevel0" id="functionLevel0" data-related="functionLevel1" data-type="functions">
                            <option value=""></option>
			                <?php foreach($functionLevels as $functionLevel): ?>
                                <option value="<?php echo $functionLevel['id']; ?>"><?php echo $functionLevel['value'];?></option>
			                <?php endforeach; ?>
                        </select>
		                <?php $initialBusinesslineDisplayStyle = "display: none;"; ?>
	                <?php endif; ?>
                </div>
                <div id="functionLevel1_container" style="<?php echo $functionLevels[0]['id']; ?>">
                    <select class="carerix_required" name="functionLevel1" id="functionLevel1"></select>
                </div>
                <?php if (@$errors['functionLevel1']): ?>
                    <span class="error">
                        <?php echo $errors['functionLevel1']; ?>
                    </span>
                <?php endif; ?>


                <div>
	                <?php if (count($functionLevels) == 1) : ?>
		                <?php $initialBusinesslineDisplayStyle = ""; ?>
                        <input type="hidden" name="functionLevel0_2" id="functionLevel0_2" value="<?php echo $functionLevels[0]['id']; ?>" data-related="functionLevel1_2" data-type="functions">
	                <?php else: ?>
                        <select name="functionLevel0_2" id="functionLevel0_2" data-related="functionLevel1_2" data-type="functions">
                            <option value=""></option>
			                <?php foreach($functionLevels as $functionLevel): ?>
                                <option value="<?php echo $functionLevel['id']; ?>"><?php echo $functionLevel['value'];?></option>
			                <?php endforeach; ?>
                        </select>
		                <?php $initialBusinesslineDisplayStyle = "display: none;"; ?>
	                <?php endif; ?>
                </div>
                <div id="functionLevel1_2_container" style="<?php echo $functionLevels[0]['id']; ?>">
                    <select name="functionLevel1_2" id="functionLevel1_2"></select>
                </div>
                <?php if (@$errors['functionLevel1_2']): ?>
                    <span class="error">
                        <?php echo $errors['functionLevel1_2']; ?>
                    </span>
                <?php endif; ?>
            </div>


            <?php
                if(isset($agreement)) echo $agreement;
            ?>


            <?php if(isset($captcha) && $captcha == 'on'): ?>
                <div class="captcha_container">
                    <label for="captcha_code"><?php echo $labels['general.message.text.captchaText']; ?></label>

                    <?php echo Carerix\Captcha\Captcha::displayCaptcha(); ?>

                    <?php if(isset($errors['captcha'])): ?>
                        <span class="error">
                            <?php echo $errors['captcha']; ?>
                        </span>
                    <?php endif; ?>
                </div>
            <?php endif; ?>
        
            <div id="submit_container">
                <input id="subscribe_button" type="submit" value="<?php echo $labels['general.button.subscribe']; ?>" >
            </div>
	    </form>
    </div>
<?php
$json_functionLevels = json_encode($functionLevels);
$json_countryRegions = json_encode($countryRegions);
$js = <<<EOT
    carerix_jQuery(document).ready(function(e){
        
        var $ = carerix_jQuery,
            jsonFunctions,
            selectData = {
                'functions' : {$json_functionLevels},
                'countries' : {$json_countryRegions}
            };
            	
        $('select[data-related], input[data-related]').change(function(e){
            var children = [],
                options = '',
                type = $(this).attr('data-type'),
                relatedID1 = $(this).attr('data-related'),
                relatedID2 = $(this).attr('data-related2'),
                relatedID3 = $(this).attr('data-related3'),
                relatedID4 = $(this).attr('data-related4'),
                data = selectData[type];
            
            if (!relatedID1 || !data) {
                return;
            }
                
            for(var i = 0; i < data.length; i++) {
                if(data[i].id == $(this).val()) {
                    children = data[i].children;
                    break;
                }
            }
            if(children.length > 0) {
                options += '<option value=""></option>';
                for(var j = 0; j < children.length; j++) {
                    options += '<option value="'+children[j]['id']+'">'+children[j]['value']+'</option>';
                }
                $('#' + relatedID1).html(options);
                $('#' + relatedID2).html(options);
                $('#' + relatedID3).html(options);
                $('#' + relatedID4).html(options);
                
                $('#' + relatedID1 + '_container').show();
                $('#' + relatedID2 + '_container').show();
                $('#' + relatedID3 + '_container').show();
                $('#' + relatedID4 + '_container').show();
            } else {
                $('#' + relatedID1 + '_container').hide();
                $('#' + relatedID2 + '_container').hide();
                $('#' + relatedID3 + '_container').hide();
                $('#' + relatedID4 + '_container').hide();
            }            
        });
        
        
//        jsonFunctions = selectData['functions'];
//        if(jsonFunctions.length == 1 && jsonFunctions[0]) {
//            var element = $('#functionLevel0');
//                element.find('option:first-child').attr('selected', 'selected');
//                element.css('display', 'none');
//                element.change();
//               
//            if (jsonFunctions[0]['children'].length <= 1) {
//                $('#functions_container').css('display', 'none');
//            }
//        }
        

        $('#prefCountry1Node').trigger('change');
        $('#functionLevel0').trigger('change');
        $('#functionLevel0_2').trigger('change');
    });
EOT;
wp_register_script( 'subscribe-handle-footer', '', [], '', true );
wp_enqueue_script( 'subscribe-handle-footer'  );
wp_add_inline_script("subscribe-handle-footer", $js);
endif;